<?php

class PageMeteo extends Page
{
  var $FullTitle = 'Stav meteostanice';
  var $ShortTitle = 'Meteostanice';
  var $ParentClass = 'PagePortal';

  function Show()
  {
    $Output = 'Stav meteostanice:<br/>';
    $Output .= '<img src="'.$this->System->Link('/Modules/Meteostation/cache/1.png').'" alt="stav meteostanice"/>';
    return $Output;
  }
}

class MeteoStation extends Model
{
  var $Id;
  var $Name;
  var $Period;
  var $URL;

  function DownloadData()
  {
    $XmlData = simplexml_load_file($this->URL);

    $Data = array('MeteoStation' => $this->Id,
      'WindSpeed' => trim($XmlData->windspeed),
      'WindDir' => trim($XmlData->winddir),
      'WindGust' => trim($XmlData->windgust),
      'Pressure' => trim($XmlData->pressure),
      'SysTemp' => trim($XmlData->systemp),
      'Temperature' => trim($XmlData->temperature),
      'BarAltitude' => trim($XmlData->baraltitude),
      'WindChill' => trim($XmlData->windchill),
      'RelHumidity' => trim($XmlData->relhumidity),
      'AbsHumidity' => trim($XmlData->abshumidity),
      'DewPoint' => trim($XmlData->dewpoint)
    );
    $this->Database->insert('MeteoStationMeasure', array(
      'Time' => TimeToMysqlDateTime(time()), 'MeteoStation' => $Data['MeteoStation'],
      'WindSpeed' => $Data['WindSpeed'], 'WindDir' => $Data['WindDir'],
      'WindGust' => $Data['WindGust'], 'Pressure' => $Data['Pressure'],
      'SysTemp' => $Data['SysTemp'], 'Temperature' => $Data['Temperature'],
      'BarAltitude' => $Data['BarAltitude'], 'WindChill' => $Data['WindChill'],
      'RelHumidity' => $Data['RelHumidity'], 'AbsHumidity' => $Data['AbsHumidity'],
      'DewPoint' => $Data['DewPoint']));
    $this->Data = $Data;
  }

  function CreateImage($FileName)
  {
    $Image = new Image();
    $Image->SetSize(150, 150);
    $Image->Brush->Color = COLOR_WHITE;
    $Image->FillRect(0, 0, $Image->GetWidth(), $Image->GetHeight());
    //$Image->Font->Color = COLOR_RED;
    //$Image->Line(10, 10, 100, 100);
    $Image->TextOut(10, 10, 'Meteo '.$this->Name);
    $Image->TextOut(10, 30, 'Teplote: '.$this->Data['Temperature'].' °C');
    $Image->SaveToFile($FileName);
  }

  function LoadFromDb()
  {
    $DbResult = $this->Database->select('Meteostation', '*', 'Id = '.$this->Id);
    $DbRow = $DbResult->fetch_assoc();
    $this->Name = $DbRow['Name'];
    $this->URL = $DbRow['URL'];
    $this->Period = $DbRow['Period'];
  }
}

class ModuleMeteoStation extends AppModule
{
  var $Data;

  function __construct($System)
  {
    parent::__construct($System);
    $this->Name = 'MeteoStation';
    $this->Version = '1.0';
    $this->Creator = 'Chronos';
    $this->License = 'GNU/GPLv3';
    $this->Description = 'Gathering and presentation of data from network meteostation.';
    $this->Dependencies = array();
  }

  function DownloadAll()
  {
    $DbResult = $this->Database->select('MeteoStation', '*');
    while ($DbRow = $DbResult->fetch_assoc())
    {
      $MeteoStation = new MeteoStation();
      $MeteoStation->Id = $DbRow['Id'];
      $MeteoStation->LoadFromDb();
      $MeteoStation->DownloadData();
      $MeteoStation->CreateImage('cache/'.$DbRow['Id'].'.png');
    }
  }


  function DoInstall()
  {
  }

  function DoUninstall()
  {
  }

  function DoStart()
  {
    $this->System->RegisterPage('meteo', 'PageMeteo');
  }

  function DoStop()
  {
  }
}
